diff --git a/src/main/java/net/minecraft/client/gui/GuiSelectServer.java b/src/main/java/net/minecraft/client/gui/SelectServerScreen.java
similarity index 64%
rename from src/main/java/net/minecraft/client/gui/GuiSelectServer.java
rename to src/main/java/net/minecraft/client/gui/SelectServerScreen.java
index d360f3b1e..af952745d 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSelectServer.java
+++ b/src/main/java/net/minecraft/client/gui/SelectServerScreen.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.net.thread.ThreadPingServer;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -15,30 +15,30 @@ import java.io.File;
 import java.util.HashMap;
 import java.util.Map;
 
-public class GuiSelectServer extends GuiScreen {
+public class SelectServerScreen extends Screen {
 
 	protected String screenTitle = "Select server";
 	private boolean selected = false;
 	private int selectedServer;
 	private SavedServerList savedServerList;
-	private GuiServerSlot worldSlotContainer;
+	private ServerSlot worldSlotContainer;
 	private boolean deleting;
 	
-	public GuiButton buttonConnect;
-	public GuiButton buttonDirectConnect;
-	public GuiButton buttonAdd;
+	public ButtonElement buttonConnect;
+	public ButtonElement buttonDirectConnect;
+	public ButtonElement buttonAdd;
 	
-	public GuiButton buttonEdit;
-	public GuiButton buttonDelete;
-	public GuiButton buttonRefresh;
-	public GuiButton buttonCancel;
+	public ButtonElement buttonEdit;
+	public ButtonElement buttonDelete;
+	public ButtonElement buttonRefresh;
+	public ButtonElement buttonCancel;
 
-	GuiTooltip tooltip;
+	TooltipElement tooltip;
 
 	private Map<ServerData, ThreadPingServer> pingThreads = new HashMap<>();
 
-	public GuiSelectServer(GuiScreen guiscreen) {
-		super(guiscreen);
+	public SelectServerScreen(Screen parent) {
+		super(parent);
 	}
 
 	@Override
@@ -46,8 +46,8 @@ public class GuiSelectServer extends GuiScreen {
 		I18n stringtranslate = I18n.getInstance();
 		screenTitle = stringtranslate.translateKey("gui.select_server.label.title");
 		loadSavedServers();
-		worldSlotContainer = new GuiServerSlot(this);
-		tooltip = new GuiTooltip(mc);
+		worldSlotContainer = new ServerSlot();
+		tooltip = new TooltipElement(mc);
 		initButtons();
 		refresh();
 	}
@@ -64,20 +64,20 @@ public class GuiSelectServer extends GuiScreen {
 		int y1 = height - 52;
 		int y2 = height - 28;
 		
-		buttonConnect = add(new GuiButton(0, x1, y1, 100, 20, trans.translateKey("gui.select_server.button.join_server")));
-		buttonDirectConnect = add(new GuiButton(0, x1 + 104, y1, 100, 20, trans.translateKey("gui.select_server.button.direct_connect")));
-		buttonAdd = add(new GuiButton(0, x1 + 208, y1, 100, 20, trans.translateKey("gui.select_server.button.add_server")));
+		buttonConnect = add(new ButtonElement(0, x1, y1, 100, 20, trans.translateKey("gui.select_server.button.join_server")));
+		buttonDirectConnect = add(new ButtonElement(0, x1 + 104, y1, 100, 20, trans.translateKey("gui.select_server.button.direct_connect")));
+		buttonAdd = add(new ButtonElement(0, x1 + 208, y1, 100, 20, trans.translateKey("gui.select_server.button.add_server")));
 		
-		buttonEdit = add(new GuiButton(0, x1, y2, 74, 20, trans.translateKey("gui.select_server.button.edit")));
-		buttonDelete = add(new GuiButton(0, x1 + 78, y2, 74, 20, trans.translateKey("gui.select_server.button.delete")));
-		buttonRefresh = add(new GuiButton(0, x1 + 156, y2, 74, 20, trans.translateKey("gui.select_server.button.refresh")));
-		buttonCancel = add(new GuiButton(0, x1 + 234, y2, 74, 20, trans.translateKey("gui.select_server.button.cancel")));
+		buttonEdit = add(new ButtonElement(0, x1, y2, 74, 20, trans.translateKey("gui.select_server.button.edit")));
+		buttonDelete = add(new ButtonElement(0, x1 + 78, y2, 74, 20, trans.translateKey("gui.select_server.button.delete")));
+		buttonRefresh = add(new ButtonElement(0, x1 + 156, y2, 74, 20, trans.translateKey("gui.select_server.button.refresh")));
+		buttonCancel = add(new ButtonElement(0, x1 + 234, y2, 74, 20, trans.translateKey("gui.select_server.button.cancel")));
 		
 		setButtonsEnabled(false);
 	}
 
 	@Override
-	protected void buttonPressed(GuiButton button) {
+	protected void buttonClicked(ButtonElement button) {
 		if(!button.enabled) {
 			return;
 		}
@@ -86,7 +86,7 @@ public class GuiSelectServer extends GuiScreen {
 			if (serverName != null) {
 				deleting = true;
 				I18n i18n = I18n.getInstance();
-				GuiPopup popup = new PopupBuilder(this, 250)
+				PopupScreen popup = new PopupBuilder(this, 250)
 					.closeOnEsc(0)
 					.withLabel("gui.select_server.label.delete_title")
 					.withLabel("gui.select_server.label.delete_confirm.1")
@@ -100,24 +100,24 @@ public class GuiSelectServer extends GuiScreen {
 						}
 					})
 					.build();
-				mc.displayGuiScreen(popup);
+				mc.displayScreen(popup);
 			}
 		} else if(button == buttonConnect) {
 			selectServer(selectedServer);
 		} else if(button == buttonDirectConnect) {
-			mc.displayGuiScreen(new GuiConnectToIP(this));
+			mc.displayScreen(new ConnectToIpScreen(this));
 		} else if(button == buttonAdd) {
-			mc.displayGuiScreen(new GuiAddServer(this, savedServerList));
+			mc.displayScreen(new AddServerScreen(this, savedServerList));
 			savedServerList.writeToFile();
 		} else if(button == buttonCancel) {
-			mc.displayGuiScreen(parentScreen);
+			mc.displayScreen(parentScreen);
 		} else if(button == buttonRefresh) {
 			refresh();
 		} else if(button == buttonEdit) {
 			ServerData serverData = savedServerList.servers.get(selectedServer);
 			
 			if(serverData != null) {
-				GuiPopup popup = new PopupBuilder(this, 140)
+				PopupScreen popup = new PopupBuilder(this, 140)
 						.closeOnEsc(0).closeOnClickOut(0).closeOnEnter(1)
 						.withLabel("gui.select_server.label.edit.1")
 						.withLabel("gui.select_server.label.edit.2")
@@ -135,7 +135,7 @@ public class GuiSelectServer extends GuiScreen {
 								refresh();
 							}
 						}).build();
-				mc.displayGuiScreen(popup);
+				mc.displayScreen(popup);
 			}
 			
 		}
@@ -189,14 +189,14 @@ public class GuiSelectServer extends GuiScreen {
 	}
 
 	public void selectServer(int i) {
-		mc.displayGuiScreen(null);
+		mc.displayScreen(null);
 		if (selected) {
 			return;
 		}
 		selected = true;
 		ServerData server = savedServerList.servers.get(selectedServer);
 		ServerAddress address = server.getServerAddress();
-		mc.displayGuiScreen(new GuiConnecting(mc, address.getIP(), address.getPort()));
+		mc.displayScreen(new ConnectingScreen(mc, address.getIP(), address.getPort()));
 	}
 
 	public void deleteWorld(boolean flag, int i) {
@@ -206,24 +206,21 @@ public class GuiSelectServer extends GuiScreen {
 				savedServerList.servers.remove(i);
 				savedServerList.writeToFile();
 			}
-			mc.displayGuiScreen(this);
+			mc.displayScreen(this);
 		}
 	}
 
 	@Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick) {
-		worldSlotContainer.render(mouseX, mouseY, partialTick);
-		drawStringCentered(fontRenderer, screenTitle, width / 2, 20, 0xffffff);
-		super.drawScreen(mouseX, mouseY, partialTick);
+	public void render(int xm, int ym, float partialTick) {
+		worldSlotContainer.render(xm, ym, partialTick);
+		drawStringCentered(font, screenTitle, width / 2, 20, 0xffffff);
+		super.render(xm, ym, partialTick);
 	}
 	
-	class GuiServerSlot extends ScrolledSelectionList {
+	class ServerSlot extends ScrolledSelectionList {
 
-		final GuiSelectServer guiSelectServer;
-		
-		public GuiServerSlot(GuiSelectServer parent) {
-			super(parent.mc, parent.width, parent.height, 32, parent.height - 64, 36);
-			this.guiSelectServer = parent;
+		public ServerSlot() {
+			super(mc, width, height, 32, height - 64, 36);
 		}
 
 		@Override
@@ -244,7 +241,7 @@ public class GuiSelectServer extends GuiScreen {
 			}*/
 			
 			if (doubleClicked && enableButtons) {
-				guiSelectServer.selectServer(itemIndex);
+				selectServer(itemIndex);
 			}
 		}
 
@@ -260,7 +257,7 @@ public class GuiSelectServer extends GuiScreen {
 
 		@Override
 		protected void renderHoleBackground() {
-			guiSelectServer.drawDefaultBackground();
+			renderBackground();
 		}
 
 		@Override
@@ -269,31 +266,31 @@ public class GuiSelectServer extends GuiScreen {
 			String line1 = server.nickname;
 			String line2 = server.address;
 
-			guiSelectServer.drawString(guiSelectServer.fontRenderer, line1, x + 2, y + 1, 0xffffff);
-			if (server.showIp) guiSelectServer.drawString(guiSelectServer.fontRenderer, line2, x + 2, y + 12 + 10, 0x404040);
+			drawString(font, line1, x + 2, y + 1, 0xffffff);
+			if (server.showIp) drawString(font, line2, x + 2, y + 12 + 10, 0x404040);
 			if (server.isUp && server.protocolVersion != Global.MP_PROTOCOL_VERSION) {
 				String outdated = I18n.getInstance().translateKey("gui.select_server.label.outdated");
-				int width = guiSelectServer.fontRenderer.getStringWidth(outdated);
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, outdated, x + 220 - width - 4, y + 1, 0xFF0000);
-				width = guiSelectServer.fontRenderer.getStringWidth(server.version);
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, server.version, x + 220 - width - 4, y + 12, 0xFF0000);
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, server.motd, x + 2, y + 12, 0x808080);
+				int width = font.getStringWidth(outdated);
+				drawString(font, outdated, x + 220 - width - 4, y + 1, 0xFF0000);
+				width = font.getStringWidth(server.version);
+				drawString(font, server.version, x + 220 - width - 4, y + 12, 0xFF0000);
+				drawString(font, server.motd, x + 2, y + 12, 0x808080);
 			} else if (server.isUp) {
 				String latency = server.latency + "ms";
-				int width = guiSelectServer.fontRenderer.getStringWidth(latency);
+				int width = font.getStringWidth(latency);
 				float green = 1.0f - MathHelper.clamp((float)server.latency / 500.0F, 0.0F, 1.0F);
 				float red = 1.0F - green;
 				int argb = 0xFF000000 | (int)(255.0F * red) << 16 | (int)(255.0F * green) << 8;
 
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, latency, x + 220 - width - 4, y + 1, argb);
+				drawString(font, latency, x + 220 - width - 4, y + 1, argb);
 				String players = server.currentPlayers + "/" + server.maxPlayers;
-				width = guiSelectServer.fontRenderer.getStringWidth(players);
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, players, x + 220 - width - 4, y + 12, 0x808080);
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, server.motd, x + 2, y + 12, 0x808080);
+				width = font.getStringWidth(players);
+				drawString(font, players, x + 220 - width - 4, y + 12, 0x808080);
+				drawString(font, server.motd, x + 2, y + 12, 0x808080);
 			} else {
 				String down = I18n.getInstance().translateKey("gui.select_server.label.down");
-				int width = guiSelectServer.fontRenderer.getStringWidth(down);
-				guiSelectServer.drawString(guiSelectServer.fontRenderer, down, x + 220 - width - 4, y + 1, 0xFF0000);
+				int width = font.getStringWidth(down);
+				drawString(font, down, x + 220 - width - 4, y + 1, 0xFF0000);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/client/gui/GuiSelectWorld.java b/src/main/java/net/minecraft/client/gui/SelectWorldScreen.java
similarity index 83%
rename from src/main/java/net/minecraft/client/gui/GuiSelectWorld.java
rename to src/main/java/net/minecraft/client/gui/SelectWorldScreen.java
index 11037f723..bbef928fb 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSelectWorld.java
+++ b/src/main/java/net/minecraft/client/gui/SelectWorldScreen.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
@@ -16,31 +16,30 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.type.WorldType;
 import org.lwjgl.input.Keyboard;
 
-import java.security.Key;
 import java.text.DateFormat;
 import java.text.SimpleDateFormat;
 import java.util.Collections;
 import java.util.Date;
 import java.util.List;
 
-public class GuiSelectWorld extends GuiScreen
+public class SelectWorldScreen extends Screen
 {
     private final DateFormat dateFormatter = new SimpleDateFormat();
     protected String stringTitle;
     private boolean selected;
     private int selectedWorld;
     private List<SaveFile> saveList;
-    private GuiWorldSlot worldSlotContainer;
+    private WorldSlot worldSlotContainer;
     private String stringWorld;
     private String stringConversion;
     private boolean deleting;
-    private GuiButton buttonRename;
-    private GuiButton buttonSelect;
-    private GuiButton buttonDelete;
+    private ButtonElement buttonRename;
+    private ButtonElement buttonSelect;
+    private ButtonElement buttonDelete;
 
-    public GuiSelectWorld(GuiScreen guiscreen)
+    public SelectWorldScreen(Screen parent)
     {
-        super(guiscreen);
+        super(parent);
         stringTitle = "Select world";
         selected = false;
         selectedWorld = -1;
@@ -58,24 +57,24 @@ public class GuiSelectWorld extends GuiScreen
             stringConversion = i18n.translateKey("gui.select_world.label.outdated");
         }
         loadSaves();
-        worldSlotContainer = new GuiWorldSlot();
+        worldSlotContainer = new WorldSlot();
         initButtons();
     }
 
     @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY) {
-        super.keyTyped(c, key, mouseX, mouseY);
-        if (key == Keyboard.KEY_UP) {
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        super.keyPressed(eventCharacter, eventKey, mx, my);
+        if (eventKey == Keyboard.KEY_UP) {
             if (selectedWorld > 0) {
                 worldSlotContainer.selectItem(selectedWorld - 1, false);
             }
         }
-        if (key == Keyboard.KEY_DOWN) {
+        if (eventKey == Keyboard.KEY_DOWN) {
             if (selectedWorld < saveList.size() - 1) {
                 worldSlotContainer.selectItem(selectedWorld + 1, false);
             }
         }
-        if (key == Keyboard.KEY_DELETE) {
+        if (eventKey == Keyboard.KEY_DELETE) {
             tryDeleteWorld(Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT));
         }
     }
@@ -110,11 +109,11 @@ public class GuiSelectWorld extends GuiScreen
     public void initButtons()
     {
         I18n i18n = I18n.getInstance();
-        controlList.add(buttonSelect = new GuiButton(1, width / 2 - 154, height - 52, 150, 20, i18n.translateKey("gui.select_world.button.play_selected_world")));
-        controlList.add(buttonRename = new GuiButton(6, width / 2 - 154, height - 28, 70, 20, i18n.translateKey("gui.select_world.button.rename")));
-        controlList.add(buttonDelete = new GuiButton(2, width / 2 - 74, height - 28, 70, 20, i18n.translateKey("gui.select_world.button.delete")));
-        controlList.add(new GuiButton(3, width / 2 + 4, height - 52, 150, 20, i18n.translateKey("gui.select_world.button.create_new_world")));
-        controlList.add(new GuiButton(0, width / 2 + 4, height - 28, 150, 20, i18n.translateKey("gui.select_world.button.cancel")));
+        buttons.add(buttonSelect = new ButtonElement(1, width / 2 - 154, height - 52, 150, 20, i18n.translateKey("gui.select_world.button.play_selected_world")));
+        buttons.add(buttonRename = new ButtonElement(6, width / 2 - 154, height - 28, 70, 20, i18n.translateKey("gui.select_world.button.rename")));
+        buttons.add(buttonDelete = new ButtonElement(2, width / 2 - 74, height - 28, 70, 20, i18n.translateKey("gui.select_world.button.delete")));
+        buttons.add(new ButtonElement(3, width / 2 + 4, height - 52, 150, 20, i18n.translateKey("gui.select_world.button.create_new_world")));
+        buttons.add(new ButtonElement(0, width / 2 + 4, height - 28, 150, 20, i18n.translateKey("gui.select_world.button.cancel")));
         buttonSelect.enabled = false;
         buttonRename.enabled = false;
         buttonDelete.enabled = false;
@@ -144,7 +143,7 @@ public class GuiSelectWorld extends GuiScreen
                 deleteWorld(true, selectedWorld);
             } else {
                 I18n i18n = I18n.getInstance();
-                GuiPopup popup = new PopupBuilder(this, 250)
+                PopupScreen popup = new PopupBuilder(this, 250)
                     .closeOnEsc(0)
                     .withLabel("gui.select_world.label.delete_title")
                     .withLabel("gui.select_world.label.delete_confirm.1")
@@ -158,14 +157,14 @@ public class GuiSelectWorld extends GuiScreen
                         }
                     })
                     .build();
-                mc.displayGuiScreen(popup);
+                mc.displayScreen(popup);
             }
         }
 
     }
 
     @Override
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
         if(!button.enabled)
         {
@@ -181,12 +180,12 @@ public class GuiSelectWorld extends GuiScreen
         }
         else if(button.id == 3)
         {
-            mc.displayGuiScreen(new GuiCreateWorld(this));
+            mc.displayScreen(new CreateWorldScreen(this));
         }
         else if(button.id == 6)
         {
             I18n i18n = I18n.getInstance();
-            GuiPopup popup = new PopupBuilder(this, 140)
+            PopupScreen popup = new PopupBuilder(this, 140)
                     .closeOnEsc(0)
                     .closeOnEnter(1)
                     .withLabel("gui.select_world.label.rename_title")
@@ -203,11 +202,11 @@ public class GuiSelectWorld extends GuiScreen
                         }
                     }))
                     .build();
-            mc.displayGuiScreen(popup);
+            mc.displayScreen(popup);
         }
         else if(button.id == 0)
         {
-            mc.displayGuiScreen(parentScreen);
+            mc.displayScreen(parentScreen);
         }
     }
 
@@ -220,7 +219,7 @@ public class GuiSelectWorld extends GuiScreen
             return;
         }
 
-        mc.displayGuiScreen(null);
+        mc.displayScreen(null);
         if(selected)
         {
             return;
@@ -233,7 +232,7 @@ public class GuiSelectWorld extends GuiScreen
             s = "World" + i;
         }
         mc.startWorld(s, getSaveName(i), 0L);
-        mc.displayGuiScreen(null);
+        mc.displayScreen(null);
     }
 
     public void deleteWorld(boolean flag, int i)
@@ -249,21 +248,21 @@ public class GuiSelectWorld extends GuiScreen
                 loadSaves();
                 selectedWorld = -1;
             }
-            mc.displayGuiScreen(this);
+            mc.displayScreen(this);
         }
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
-        worldSlotContainer.render(mouseX, mouseY, partialTick);
-        drawStringCentered(fontRenderer, stringTitle, width / 2, 20, 0xffffff);
-        super.drawScreen(mouseX, mouseY, partialTick);
+        worldSlotContainer.render(xm, ym, partialTick);
+        drawStringCentered(font, stringTitle, width / 2, 20, 0xffffff);
+        super.render(xm, ym, partialTick);
     }
 
-    class GuiWorldSlot extends ScrolledSelectionList
+    class WorldSlot extends ScrolledSelectionList
     {
-        public GuiWorldSlot()
+        public WorldSlot()
         {
             super(mc, width, height, 32, height - 64, 36);
         }
@@ -304,7 +303,7 @@ public class GuiSelectWorld extends GuiScreen
         @Override
         protected void renderHoleBackground()
         {
-            drawDefaultBackground();
+            renderBackground();
         }
 
         @Override
@@ -346,9 +345,9 @@ public class GuiSelectWorld extends GuiScreen
                 }
             }
 
-            drawString(fontRenderer, s, x + 2, y + 1, 0xffffff);
-            drawString(fontRenderer, s1, x + 2, y + 12, 0x808080);
-            drawString(fontRenderer, s2, x + 2, y + 12 + 10, 0x808080);
+            drawString(font, s, x + 2, y + 1, 0xffffff);
+            drawString(font, s1, x + 2, y + 12, 0x808080);
+            drawString(font, s2, x + 2, y + 12 + 10, 0x808080);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/GuiEditSign.java b/src/main/java/net/minecraft/client/gui/SignEditorScreen.java
similarity index 77%
rename from src/main/java/net/minecraft/client/gui/GuiEditSign.java
rename to src/main/java/net/minecraft/client/gui/SignEditorScreen.java
index 881c2f6f4..dc09c7ac3 100644
--- a/src/main/java/net/minecraft/client/gui/GuiEditSign.java
+++ b/src/main/java/net/minecraft/client/gui/SignEditorScreen.java
@@ -12,9 +12,9 @@ import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
-public class GuiEditSign extends GuiScreen
+public class SignEditorScreen extends Screen
 {
-    public GuiEditSign(SignBlockEntity tileentitysign)
+    public SignEditorScreen(SignBlockEntity tileentitysign)
     {
         screenTitle = I18n.getInstance().translateKey("gui.edit_sign.label.title");
         editLine = 0;
@@ -24,7 +24,7 @@ public class GuiEditSign extends GuiScreen
     @Override
 	public void init()
     {
-        controlList.clear();
+        buttons.clear();
         Keyboard.enableRepeatEvents(true);
 
         Block block = entitySign.getBlockType();
@@ -33,14 +33,14 @@ public class GuiEditSign extends GuiScreen
             yOffset = 36;
         }
 
-        controlList.add(new GuiButton(0, width / 2 - 100, 150 + 50 + yOffset, I18n.getInstance().translateKey("gui.edit_sign.button.done")));
+        buttons.add(new ButtonElement(0, width / 2 - 100, 150 + 50 + yOffset, I18n.getInstance().translateKey("gui.edit_sign.button.done")));
         
-        controlList.add(new GuiButton(1, width / 2 - 20, 120 + 50 + yOffset, 20, 20, "<"));
-        controlList.add(new GuiButton(2, width / 2, 120 + 50 + yOffset, 20, 20, ">"));
+        buttons.add(new ButtonElement(1, width / 2 - 20, 120 + 50 + yOffset, 20, 20, "<"));
+        buttons.add(new ButtonElement(2, width / 2, 120 + 50 + yOffset, 20, 20, ">"));
     }
 
     @Override
-	public void onClosed()
+	public void removed()
     {
         Keyboard.enableRepeatEvents(false);
         // I have no idea how the hell the world is null sometimes
@@ -58,7 +58,7 @@ public class GuiEditSign extends GuiScreen
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(!button.enabled)
         {
@@ -67,7 +67,7 @@ public class GuiEditSign extends GuiScreen
         if(button.id == 0)
         {
             entitySign.setChanged();
-            mc.displayGuiScreen(null);
+            mc.displayScreen(null);
         }
         if (button.id == 1)
         {
@@ -88,36 +88,36 @@ public class GuiEditSign extends GuiScreen
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-    	if(i == Keyboard.KEY_ESCAPE)
+    	if(eventKey == Keyboard.KEY_ESCAPE)
     	{
             entitySign.setChanged();
-    		mc.displayGuiScreen(null);
+    		mc.displayScreen(null);
     	}
-        if(i == 200)
+        if(eventKey == 200)
         {
             editLine = editLine - 1 & 3;
         }
-        if(i == 208 || i == 28 || i == 156)
+        if(eventKey == 208 || eventKey == 28 || eventKey == 156)
         {
             editLine = editLine + 1 & 3;
         }
-        if(i == 14 && entitySign.signText[editLine].length() > 0)
+        if(eventKey == 14 && entitySign.signText[editLine].length() > 0)
         {
             entitySign.signText[editLine] = entitySign.signText[editLine].substring(0, entitySign.signText[editLine].length() - 1);
         }
-        if ((allowedCharacters.indexOf(c) >= 0 || Character.isLetterOrDigit(c)) && entitySign.signText[editLine].length() < 15)
+        if ((allowedCharacters.indexOf(eventCharacter) >= 0 || Character.isLetterOrDigit(eventCharacter)) && entitySign.signText[editLine].length() < 15)
         {
-            entitySign.signText[editLine] += c;
+            entitySign.signText[editLine] += eventCharacter;
         }
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        drawDefaultBackground();
-        drawStringCentered(fontRenderer, screenTitle, width / 2, 40, 0xffffff);
+        renderBackground();
+        drawStringCentered(font, screenTitle, width / 2, 40, 0xffffff);
         GL11.glPushMatrix();
         GL11.glTranslatef((float) width / 2, 0.0F, 50F);
         float scale = 93.75F;
@@ -156,9 +156,9 @@ public class GuiEditSign extends GuiScreen
         entitySign.lineBeingEdited = -1;
         GL11.glPopMatrix();
         
-        drawStringCentered(fontRenderer, I18n.getInstance().translateKey(entitySign.getPicture().getLanguageKey()), width / 2, 100 + 50 + yOffset, 0xFFFFFF);
+        drawStringCentered(font, I18n.getInstance().translateKey(entitySign.getPicture().getLanguageKey()), width / 2, 100 + 50 + yOffset, 0xFFFFFF);
 
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
     }
 
     protected String screenTitle;
diff --git a/src/main/java/net/minecraft/client/gui/GuiSleepMP.java b/src/main/java/net/minecraft/client/gui/SleepScreenMP.java
similarity index 71%
rename from src/main/java/net/minecraft/client/gui/GuiSleepMP.java
rename to src/main/java/net/minecraft/client/gui/SleepScreenMP.java
index 8f23abf8f..93e9c15f9 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSleepMP.java
+++ b/src/main/java/net/minecraft/client/gui/SleepScreenMP.java
@@ -12,10 +12,10 @@ import org.lwjgl.input.Keyboard;
 //            GuiChat, StringTranslate, GuiButton, LocalPlayer,
 //            MultiplayerLocalPlayer, PlayerCommandPacket, ClientPacketHandler
 
-public class GuiSleepMP extends GuiChat
+public class SleepScreenMP extends ChatScreen
 {
 
-    public GuiSleepMP()
+    public SleepScreenMP()
     {
     }
 
@@ -24,41 +24,41 @@ public class GuiSleepMP extends GuiChat
     {
         Keyboard.enableRepeatEvents(true);
         I18n stringtranslate = I18n.getInstance();
-        controlList.add(new GuiButton(1, width / 2 - 100, height - 40, stringtranslate.translateKey("gui.sleeping.multiplayer.leave_bed")));
+        buttons.add(new ButtonElement(1, width / 2 - 100, height - 40, stringtranslate.translateKey("gui.sleeping.multiplayer.leave_bed")));
 		int emotePickerYCells = (int)MathHelper.clamp(Math.ceil(ChatEmotes.getEmotes().size() / 5.0), 0, 4);
-		emotePicker = new GuiChatEmotePicker(mc, this, 5, emotePickerYCells);
+		emotePicker = new ChatEmotePickerElement(mc, this, 5, emotePickerYCells);
 		showEmotePicker = false;
     }
 
     @Override
-	public void onClosed()
+	public void removed()
     {
         Keyboard.enableRepeatEvents(false);
     }
     
     @Override
-	public void keyTyped(char c, int key, int mouseX, int mouseY) {
-    	super.keyTyped(c, key, mouseX, mouseY);
-    	if(key == Keyboard.KEY_ESCAPE) {
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+    	super.keyPressed(eventCharacter, eventKey, mx, my);
+    	if(eventKey == Keyboard.KEY_ESCAPE) {
     		func_22115_j();
     	}
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if(button.id == 1)
         {
             func_22115_j();
         } else
         {
-            super.buttonPressed(button);
+            super.buttonClicked(button);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/GuiSleepSP.java b/src/main/java/net/minecraft/client/gui/SleepScreenSP.java
similarity index 59%
rename from src/main/java/net/minecraft/client/gui/GuiSleepSP.java
rename to src/main/java/net/minecraft/client/gui/SleepScreenSP.java
index b73f6a145..ee1424127 100644
--- a/src/main/java/net/minecraft/client/gui/GuiSleepSP.java
+++ b/src/main/java/net/minecraft/client/gui/SleepScreenSP.java
@@ -3,23 +3,23 @@ package net.minecraft.client.gui;
 import net.minecraft.core.lang.I18n;
 import org.lwjgl.input.Keyboard;
 
-public class GuiSleepSP extends GuiScreen{
+public class SleepScreenSP extends Screen {
 	
 	@Override
 	public void init() {
         I18n stringtranslate = I18n.getInstance();
-        controlList.add(new GuiButton(1, width / 2 - 100, height - 40, stringtranslate.translateKey("gui.sleeping.leave_bed")));
+        buttons.add(new ButtonElement(1, width / 2 - 100, height - 40, stringtranslate.translateKey("gui.sleeping.leave_bed")));
 	}
 	
 	@Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY) {
-		if(i == Keyboard.KEY_ESCAPE) {
+	public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+		if(eventKey == Keyboard.KEY_ESCAPE) {
 			wakeUp();
 		}
 	}
 	
 	@Override
-	protected void buttonPressed(GuiButton button) {
+	protected void buttonClicked(ButtonElement button) {
 		if(button.id == 1) {
 			wakeUp();
 		}
@@ -30,7 +30,7 @@ public class GuiSleepSP extends GuiScreen{
 	}
 	
 	@Override
-	public boolean pausesGame() {
+	public boolean isPauseScreen() {
 		return false;
 	}
 	
